Blame SOURCES/0005-RH-add-mpathconf.patch

38852f
---
38852f
 libmultipath/config.c |    1 
38852f
 multipath/Makefile    |    5 
38852f
 multipath/main.c      |    4 
38852f
 multipath/mpathconf   |  312 ++++++++++++++++++++++++++++++++++++++++++++++++++
38852f
 multipath/mpathconf.8 |  103 ++++++++++++++++
38852f
 5 files changed, 423 insertions(+), 2 deletions(-)
38852f
38852f
Index: multipath-tools-130222/libmultipath/config.c
38852f
===================================================================
38852f
--- multipath-tools-130222.orig/libmultipath/config.c
38852f
+++ multipath-tools-130222/libmultipath/config.c
38852f
@@ -589,6 +589,7 @@ load_config (char * file)
38852f
 		condlog(0, "/etc/multipath.conf does not exist, blacklisting all devices.");
38852f
 		condlog(0, "A default multipath.conf file is located at");
38852f
 		condlog(0, "/usr/share/doc/device-mapper-multipath-%d.%d.%d/multipath.conf", MULTIPATH_VERSION(VERSION_CODE));
38852f
+		condlog(0, "You can run /sbin/mpathconf to create or modify /etc/multipath.conf");
38852f
 		if (conf->blist_devnode == NULL) {
38852f
 			conf->blist_devnode = vector_alloc();
38852f
 			if (!conf->blist_devnode) {
38852f
Index: multipath-tools-130222/multipath/Makefile
38852f
===================================================================
38852f
--- multipath-tools-130222.orig/multipath/Makefile
38852f
+++ multipath-tools-130222/multipath/Makefile
38852f
@@ -17,22 +17,27 @@ $(EXEC): $(OBJS)
38852f
 	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS)
38852f
 	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
38852f
 	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz
38852f
+	$(GZIP) mpathconf.8 > mpathconf.8.gz
38852f
 
38852f
 install:
38852f
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
38852f
 	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
38852f
+	$(INSTALL_PROGRAM) -m 755 mpathconf $(DESTDIR)$(bindir)/
38852f
 	$(INSTALL_PROGRAM) -d $(DESTDIR)/lib/udev/rules.d
38852f
 	$(INSTALL_PROGRAM) -m 644 multipath.rules $(DESTDIR)/lib/udev/rules.d/62-multipath.rules
38852f
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
38852f
 	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
38852f
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man5dir)
38852f
 	$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)
38852f
+	$(INSTALL_PROGRAM) -m 644 mpathconf.8.gz $(DESTDIR)$(mandir)
38852f
 
38852f
 uninstall:
38852f
 	rm $(DESTDIR)/lib/udev/rules.d/62-multipath.rules
38852f
 	rm $(DESTDIR)$(bindir)/$(EXEC)
38852f
+	rm $(DESTDIR)$(bindir)/mpathconf
38852f
 	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz
38852f
 	rm $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz
38852f
+	rm $(DESTDIR)$(mandir)/mpathconf.8.gz
38852f
 
38852f
 clean:
38852f
 	rm -f core *.o $(EXEC) *.gz
38852f
Index: multipath-tools-130222/multipath/main.c
38852f
===================================================================
38852f
--- multipath-tools-130222.orig/multipath/main.c
38852f
+++ multipath-tools-130222/multipath/main.c
38852f
@@ -433,10 +433,10 @@ main (int argc, char *argv[])
38852f
 		exit(1);
38852f
 	}
38852f
 
38852f
-	if (dm_prereq())
38852f
+	if (load_config(DEFAULT_CONFIGFILE))
38852f
 		exit(1);
38852f
 
38852f
-	if (load_config(DEFAULT_CONFIGFILE))
38852f
+	if (dm_prereq())
38852f
 		exit(1);
38852f
 
38852f
 	while ((arg = getopt(argc, argv, ":dchl::FfM:v:p:b:Brtq")) != EOF ) {
38852f
Index: multipath-tools-130222/multipath/mpathconf
38852f
===================================================================
38852f
--- /dev/null
38852f
+++ multipath-tools-130222/multipath/mpathconf
38852f
@@ -0,0 +1,312 @@
38852f
+#!/bin/sh
38852f
+#
38852f
+# Copyright (C) 2010 Red Hat, Inc. All rights reserved.
38852f
+#
38852f
+# This file is part of the device-mapper-multipath package.
38852f
+#
38852f
+# This copyrighted material is made available to anyone wishing to use,
38852f
+# modify, copy, or redistribute it subject to the terms and conditions
38852f
+# of the GNU General Public License v.2.
38852f
+#
38852f
+# You should have received a copy of the GNU General Public License
38852f
+# along with this program; if not, write to the Free Software Foundation,
38852f
+# Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
38852f
+
38852f
+#
38852f
+# Simple editting of /etc/multipath.conf
38852f
+# This program was largely ripped off from lvmconf
38852f
+#
38852f
+
38852f
+unset ENABLE FIND FRIENDLY MODULE MULTIPATHD HAVE_DISABLE HAVE_FIND HAVE_BLACKLIST HAVE_DEFAULTS HAVE_FRIENDLY HAVE_MULTIPATHD HAVE_MODULE SHOW_STATUS CHANGED_CONFIG
38852f
+
38852f
+DEFAULT_CONFIGFILE="/usr/share/doc/device-mapper-multipath-0.4.9/multipath.conf"
38852f
+CONFIGFILE="/etc/multipath.conf"
38852f
+MULTIPATHDIR="/etc/multipath"
38852f
+TMPFILE=/etc/multipath/.multipath.conf.tmp
38852f
+
38852f
+function usage
38852f
+{
38852f
+	echo "usage: $0 <command>"
38852f
+	echo ""
38852f
+	echo "Commands:"
38852f
+	echo "Enable: --enable "
38852f
+	echo "Disable: --disable"
38852f
+	echo "Set user_friendly_names (Default n): --user_friendly_names <y|n>"
38852f
+	echo "Set find_multipaths (Default n): --find_multipaths <y|n>"
38852f
+	echo "Load the dm-multipath modules on enable (Default y): --with_module <y|n>"
38852f
+	echo "start/stop/reload multipathd (Default n): --with_multipathd <y|n>"
38852f
+	echo ""
38852f
+}
38852f
+
38852f
+function parse_args
38852f
+{
38852f
+	while [ -n "$1" ]; do
38852f
+		case $1 in
38852f
+			--enable)
38852f
+				ENABLE=1
38852f
+				shift
38852f
+				;;
38852f
+			--disable)
38852f
+				ENABLE=0
38852f
+				shift
38852f
+				;;
38852f
+			--user_friendly_names)
38852f
+				if [ -n "$2" ]; then
38852f
+					FRIENDLY=$2
38852f
+					shift 2
38852f
+				else
38852f
+					usage
38852f
+					exit 1
38852f
+				fi
38852f
+				;;
38852f
+			--find_multipaths)
38852f
+				if [ -n "$2" ]; then
38852f
+					FIND=$2
38852f
+					shift 2
38852f
+				else
38852f
+					usage
38852f
+					exit 1
38852f
+				fi
38852f
+				;;
38852f
+			--with_module)
38852f
+				if [ -n "$2" ]; then
38852f
+					MODULE=$2
38852f
+					shift 2
38852f
+				else
38852f
+					usage
38852f
+					exit 1
38852f
+				fi
38852f
+				;;
38852f
+			--with_multipathd)
38852f
+				if [ -n "$2" ]; then
38852f
+					MULTIPATHD=$2
38852f
+					shift 2
38852f
+				else
38852f
+					usage
38852f
+					exit 1
38852f
+				fi
38852f
+				;;
38852f
+			*)
38852f
+				usage
38852f
+				exit
38852f
+		esac
38852f
+	done
38852f
+}
38852f
+
38852f
+function validate_args
38852f
+{
38852f
+	if [ "$ENABLE" = "0" ] && [ -n "$FRIENDLY" -o -n "$FIND" -o -n "$MODULE" ]; then
38852f
+		echo "ignoring extra parameters on disable"
38852f
+		FRIENDLY=""
38852f
+		FIND=""
38852f
+		MODULE=""
38852f
+	fi
38852f
+	if [ -n "$FRIENDLY" ] && [ "$FRIENDLY" != "y" -a "$FRIENDLY" != "n" ]; then
38852f
+		echo "--user_friendly_names must be either 'y' or 'n'"
38852f
+		exit 1
38852f
+	fi
38852f
+	if [ -n "$FIND" ] && [ "$FIND" != "y" -a "$FIND" != "n" ]; then
38852f
+		echo "--find_multipaths must be either 'y' or 'n'"
38852f
+		exit 1
38852f
+	fi
38852f
+	if [ -z "$ENABLE" -a -z "$FIND" -a -z "$FRIENDLY" ]; then
38852f
+		SHOW_STATUS=1
38852f
+	fi
38852f
+	if [ -n "$MODULE" ] && [ "$MODULE" != "y" -a "$MODULE" != "n" ]; then
38852f
+		echo "--with_module must be either 'y' or 'n'"
38852f
+		exit 1
38852f
+	fi
38852f
+	if [ -n "$MULTIPATHD" ] && [ "$MULTIPATHD" != "y" -a "$MULTIPATHD" != "n" ]; then
38852f
+		echo "--with_multipathd must be either 'y' or 'n'"
38852f
+		exit 1
38852f
+	fi
38852f
+}
38852f
+
38852f
+umask 0077
38852f
+
38852f
+parse_args "$@"
38852f
+
38852f
+validate_args
38852f
+
38852f
+if [ ! -d "$MULTIPATHDIR" ]; then
38852f
+	echo "/etc/multipath/ does not exist. failing"
38852f
+	exit 1
38852f
+fi
38852f
+
38852f
+rm $TMPFILE 2> /dev/null
38852f
+if [ -f "$CONFIGFILE" ]; then
38852f
+	cp $CONFIGFILE $TMPFILE
38852f
+elif [ -f "$DEFAULT_CONFIGFILE" ]; then
38852f
+	cp $DEFAULT_CONFIGFILE $TMPFILE
38852f
+else
38852f
+	touch $TMPFILE
38852f
+fi
38852f
+
38852f
+if grep -q "^blacklist[[:space:]]*{" $TMPFILE ; then
38852f
+	HAVE_BLACKLIST=1
38852f
+fi
38852f
+
38852f
+if grep -q "^defaults[[:space:]]*{" $TMPFILE ; then
38852f
+	HAVE_DEFAULTS=1
38852f
+fi
38852f
+
38852f
+if [ -z "$MODULE" -o "$MODULE" = "y" ]; then
38852f
+	if lsmod | grep -q "dm_multipath" ; then
38852f
+		HAVE_MODULE=1
38852f
+	else
38852f
+		HAVE_MODULE=0
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ "$MULTIPATHD" = "y" ]; then
38852f
+	if service multipathd status > /dev/null ; then
38852f
+		HAVE_MULTIPATHD=1
38852f
+	else
38852f
+		HAVE_MULTIPATHD=0
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ "$HAVE_BLACKLIST" = "1" ]; then
38852f
+	if sed -n '/^blacklist[[:space:]]*{/,/^}/ p' $TMPFILE | grep -q "^[[:space:]]*devnode \"\.\?\*\"" ; then
38852f
+		HAVE_DISABLE=1
38852f
+	elif sed -n '/^blacklist[[:space:]]*{/,/^}/ p' $TMPFILE | grep -q "^[[:space:]]*#[#[:space:]]*devnode \"\.\?\*\"" ; then
38852f
+		HAVE_DISABLE=0
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ "$HAVE_DEFAULTS" = "1" ]; then
38852f
+	if sed -n '/^defaults[[:space:]]*{/,/^}/ p' $TMPFILE | grep -q "^[[:space:]]*find_multipaths[[:space:]]*\(yes\|1\)" ; then
38852f
+		HAVE_FIND=1
38852f
+	elif sed -n '/^defaults[[:space:]]*{/,/^}/ p' $TMPFILE | grep -q "^[[:space:]]*find_multipaths[[:space:]]*\(no\|0\)" ; then
38852f
+		HAVE_FIND=0
38852f
+	fi
38852f
+	if sed -n '/^defaults[[:space:]]*{/,/^}/ p' $TMPFILE | grep -q "^[[:space:]]*user_friendly_names[[:space:]]*\(yes\|1\)" ; then
38852f
+		HAVE_FRIENDLY=1
38852f
+	elif sed -n '/^defaults[[:space:]]*{/,/^}/ p' $TMPFILE | grep -q "^[[:space:]]*user_friendly_names[[:space:]]*\(no\|0\)" ; then
38852f
+		HAVE_FRIENDLY=0
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ -n "$SHOW_STATUS" ]; then
38852f
+	if [ -z "$HAVE_DISABLE" -o "$HAVE_DISABLE" = 0 ]; then
38852f
+		echo "multipath is enabled"
38852f
+	else
38852f
+		echo "multipath is disabled"
38852f
+	fi
38852f
+	if [ -z "$HAVE_FIND"  -o "$HAVE_FIND" = 0 ]; then
38852f
+		echo "find_multipaths is disabled"
38852f
+	else
38852f
+		echo "find_multipaths is enabled"
38852f
+	fi
38852f
+	if [ -z "$HAVE_FRIENDLY" -o "$HAVE_FRIENDLY" = 0 ]; then
38852f
+		echo "user_friendly_names is disabled"
38852f
+	else
38852f
+		echo "user_friendly_names is enabled"
38852f
+	fi
38852f
+	if [ -n "$HAVE_MODULE" ]; then
38852f
+		if [ "$HAVE_MODULE" = 1 ]; then
38852f
+			echo "dm_multipath module is loaded"
38852f
+		else
38852f
+			echo "dm_multipath module is not loaded"
38852f
+		fi
38852f
+	fi
38852f
+	if [ -n "$HAVE_MULTIPATHD" ]; then
38852f
+		service multipathd status
38852f
+	fi
38852f
+	exit 0
38852f
+fi
38852f
+
38852f
+if [ -z "$HAVE_BLACKLIST" ]; then
38852f
+	cat >> $TMPFILE <<- _EOF_
38852f
+
38852f
+blacklist {
38852f
+}
38852f
+_EOF_
38852f
+fi
38852f
+
38852f
+if [ -z "$HAVE_DEFAULTS" ]; then
38852f
+	cat >> $TMPFILE <<- _EOF_
38852f
+
38852f
+defaults {
38852f
+}
38852f
+_EOF_
38852f
+fi
38852f
+
38852f
+if [ "$ENABLE" = 1 ]; then
38852f
+	if [ "$HAVE_DISABLE" = 1 ]; then
38852f
+		sed -i '/^blacklist[[:space:]]*{/,/^}/ s/^[[:space:]]*devnode \"\.\?\*\"/#	devnode ".*"/' $TMPFILE
38852f
+	fi
38852f
+elif [ "$ENABLE" = 0 ]; then
38852f
+	if [ -z "$HAVE_DISABLE" ]; then
38852f
+		sed -i '/^blacklist[[:space:]]*{/ a\
38852f
+	devnode "*"
38852f
+' $TMPFILE
38852f
+	elif [ "$HAVE_DISABLE" = 0 ]; then
38852f
+		sed -i '/^blacklist[[:space:]]*{/,/^}/ s/^[[:space:]]*#[#[:space:]]*devnode \"\.\?\*\"/	devnode ".*"/' $TMPFILE
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ "$FIND" = "n" ]; then
38852f
+	if [ "$HAVE_FIND" = 1 ]; then
38852f
+		sed -i '/^defaults[[:space:]]*{/,/^}/ s/^[[:space:]]*find_multipaths[[:space:]]*\(yes\|1\)/	find_multipaths no/' $TMPFILE
38852f
+		CHANGED_CONFIG=1
38852f
+	fi
38852f
+elif [ "$FIND" = "y" ]; then
38852f
+	if [ -z "$HAVE_FIND" ]; then
38852f
+		sed -i '/^defaults[[:space:]]*{/ a\
38852f
+	find_multipaths yes
38852f
+' $TMPFILE
38852f
+		CHANGED_CONFIG=1
38852f
+	elif [ "$HAVE_FIND" = 0 ]; then
38852f
+		sed -i '/^defaults[[:space:]]*{/,/^}/ s/^[[:space:]]*find_multipaths[[:space:]]*\(no\|0\)/	find_multipaths yes/' $TMPFILE
38852f
+		CHANGED_CONFIG=1
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ "$FRIENDLY" = "n" ]; then
38852f
+	if [ "$HAVE_FRIENDLY" = 1 ]; then
38852f
+		sed -i '/^defaults[[:space:]]*{/,/^}/ s/^[[:space:]]*user_friendly_names[[:space:]]*\(yes\|1\)/	user_friendly_names no/' $TMPFILE
38852f
+		CHANGED_CONFIG=1
38852f
+	fi
38852f
+elif [ "$FRIENDLY" = "y" ]; then
38852f
+	if [ -z "$HAVE_FRIENDLY" ]; then
38852f
+		sed -i '/^defaults[[:space:]]*{/ a\
38852f
+	user_friendly_names yes
38852f
+' $TMPFILE
38852f
+		CHANGED_CONFIG=1
38852f
+	elif [ "$HAVE_FRIENDLY" = 0 ]; then
38852f
+		sed -i '/^defaults[[:space:]]*{/,/^}/ s/^[[:space:]]*user_friendly_names[[:space:]]*\(no\|0\)/	user_friendly_names yes/' $TMPFILE
38852f
+		CHANGED_CONFIG=1
38852f
+	fi
38852f
+fi
38852f
+
38852f
+if [ -f "$CONFIGFILE" ]; then
38852f
+	cp $CONFIGFILE $CONFIGFILE.old
38852f
+	if [ $? != 0 ]; then
38852f
+		echo "failed to backup old config file, $CONFIGFILE not updated"
38852f
+		exit 1
38852f
+	fi
38852f
+fi
38852f
+
38852f
+cp $TMPFILE $CONFIGFILE
38852f
+if [ $? != 0 ]; then
38852f
+	echo "failed to copy new config file into place, check $CONFIGFILE is still OK"
38852f
+	exit 1
38852f
+fi
38852f
+
38852f
+rm -f $TMPFILE
38852f
+
38852f
+if [ "$ENABLE" = 1 ]; then
38852f
+	if [ "$HAVE_MODULE" = 0 ]; then
38852f
+		modprobe dm_multipath
38852f
+	fi
38852f
+	if [ "$HAVE_MULTIPATHD" = 0 ]; then
38852f
+		service multipathd start
38852f
+	fi
38852f
+elif [ "$ENABLE" = 0 ]; then
38852f
+	if [ "$HAVE_MULTIPATHD" = 1 ]; then
38852f
+		service multipathd stop
38852f
+	fi
38852f
+elif [ -n "$CHANGED_CONFIG" -a "$HAVE_MULTIPATHD" = 1 ]; then
38852f
+	service multipathd reload
38852f
+fi
38852f
Index: multipath-tools-130222/multipath/mpathconf.8
38852f
===================================================================
38852f
--- /dev/null
38852f
+++ multipath-tools-130222/multipath/mpathconf.8
38852f
@@ -0,0 +1,103 @@
38852f
+.TH MPATHCONF 8 "June 2010" "" "Linux Administrator's Manual"
38852f
+.SH NAME
38852f
+mpathconf - A tool for configuring device-mapper-multipath
38852f
+.SH SYNOPSIS
38852f
+.B mpathconf
38852f
+.RB [\| commands \|]
38852f
+.RB [\| options \|]
38852f
+.SH DESCRIPTION
38852f
+.B mpathconf
38852f
+is a utility that creates or modifies
38852f
+.B /etc/multipath.conf.
38852f
+It can enable or disable multipathing and configure some common options.
38852f
+.B mpathconf
38852f
+can also load the
38852f
+.B dm_multipath
38852f
+module, start and stop the
38852f
+.B multipathd
38852f
+daemon, and configure the
38852f
+.B multipathd
38852f
+service to start automatically or not. If
38852f
+.B mpathconf
38852f
+is called with no commands, it will display the current configuration.
38852f
+
38852f
+The default options for mpathconf are
38852f
+.B --with_module
38852f
+The
38852f
+.B --with_multipathd
38852f
+option is not set by default.  Enabling multipathing will load the
38852f
+.B dm_multipath
38852f
+module but it will not immediately start it. This is so
38852f
+that users can manually edit their config file if necessary, before starting
38852f
+.B multipathd.
38852f
+
38852f
+If
38852f
+.B /etc/multipath.conf
38852f
+already exists, mpathconf will edit it. If it does not exist, mpathconf will
38852f
+use
38852f
+.B /usr/share/doc/device-mapper-multipath-0.4.9/multipath.conf
38852f
+as the starting file. This file has
38852f
+.B user_friendly_names
38852f
+set. If this file does not exist, mpathconf will create
38852f
+.B /etc/multipath.conf
38852f
+from scratch.  For most users, this means that
38852f
+.B user_friendly_names
38852f
+will be set by default, unless they use the
38852f
+.B --user_friendly_names n
38852f
+command.
38852f
+.SH COMMANDS
38852f
+.TP
38852f
+.B --enable
38852f
+Removes any line that blacklists all device nodes from the
38852f
+.B /etc/multipath.conf
38852f
+blacklist section.
38852f
+.TP
38852f
+.B --disable
38852f
+Adds a line that blacklists all device nodes to the
38852f
+.B /etc/multipath.conf
38852f
+blacklist section. If no blacklist section exists, it will create one.
38852f
+.TP
38852f
+.B --user_friendly_name \fP { \fBy\fP | \fBn\fP }
38852f
+If set to \fBy\fP, this adds the line
38852f
+.B user_friendly_names yes
38852f
+to the
38852f
+.B /etc/multipath.conf
38852f
+defaults section. If set to \fBn\fP, this removes the line, if present. This
38852f
+command can be used along with any other command.
38852f
+.TP
38852f
+.B --find_multipaths\fP { \fBy\fP | \fBn\fP }
38852f
+If set to \fBy\fP, this adds the line
38852f
+.B find_multipaths yes
38852f
+to the
38852f
+.B /etc/multipath.conf
38852f
+defaults section. If set to \fBn\fP, this removes the line, if present. This
38852f
+command can be used aldong with any other command.
38852f
+.SH OPTIONS
38852f
+.TP
38852f
+.B --with_module\fP { \fBy\fP | \fBn\fP }
38852f
+If set to \fBy\fP, this runs
38852f
+.B modprobe dm_multipath
38852f
+to install the multipath modules. This option only works with the
38852f
+.B --enable
38852f
+command. This option is set to \fBy\fP by default.
38852f
+.TP
38852f
+.B --with_multipathd { \fBy\fP | \fBn\fP }
38852f
+If set to \fBy\fP, this runs
38852f
+.B service multipathd start
38852f
+to start the multipathd daemon on \fB--enable\fP,
38852f
+.B service multipathd stop
38852f
+to start the multipathd daemon on \fB--disable\fP, and
38852f
+.B service multipathd reload
38852f
+to reconfigure multipathd on \fB--user_frindly_names\fP and
38852f
+\fB--find_multipaths\fP.
38852f
+This option is set to \fBn\fP by default.
38852f
+.SH FILES
38852f
+.BR /etc/multipath.conf
38852f
+.SH "SEE ALSO"
38852f
+.BR multipath.conf (5),
38852f
+.BR modprobe (8),
38852f
+.BR multipath (8),
38852f
+.BR multipathd (8),
38852f
+.BR service (8),
38852f
+.SH AUTHOR
38852f
+Benjamin Marzinski <bmarzins@redhat.com>